/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
	"time"
)

// checks if the RequestParameter type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &RequestParameter{}

// RequestParameter struct for RequestParameter
type RequestParameter struct {
	RequestId     NullableString `json:"requestId,omitempty"`
	OperationType *OperationType `json:"operationType,omitempty"`
	PropertyName  NullableString `json:"propertyName,omitempty"`
	PropertyValue NullableString `json:"propertyValue,omitempty"`
	Id            NullableString `json:"id,omitempty"`
	CreationTime  *time.Time     `json:"creationTime,omitempty"`
}

// NewRequestParameter instantiates a new RequestParameter object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewRequestParameter() *RequestParameter {
	this := RequestParameter{}
	return &this
}

// NewRequestParameterWithDefaults instantiates a new RequestParameter object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewRequestParameterWithDefaults() *RequestParameter {
	this := RequestParameter{}
	return &this
}

// GetRequestId returns the RequestId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *RequestParameter) GetRequestId() string {
	if o == nil || IsNil(o.RequestId.Get()) {
		var ret string
		return ret
	}
	return *o.RequestId.Get()
}

// GetRequestIdOk returns a tuple with the RequestId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *RequestParameter) GetRequestIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.RequestId.Get(), o.RequestId.IsSet()
}

// HasRequestId returns a boolean if a field has been set.
func (o *RequestParameter) HasRequestId() bool {
	if o != nil && o.RequestId.IsSet() {
		return true
	}

	return false
}

// SetRequestId gets a reference to the given NullableString and assigns it to the RequestId field.
func (o *RequestParameter) SetRequestId(v string) {
	o.RequestId.Set(&v)
}

// SetRequestIdNil sets the value for RequestId to be an explicit nil
func (o *RequestParameter) SetRequestIdNil() {
	o.RequestId.Set(nil)
}

// UnsetRequestId ensures that no value is present for RequestId, not even an explicit nil
func (o *RequestParameter) UnsetRequestId() {
	o.RequestId.Unset()
}

// GetOperationType returns the OperationType field value if set, zero value otherwise.
func (o *RequestParameter) GetOperationType() OperationType {
	if o == nil || IsNil(o.OperationType) {
		var ret OperationType
		return ret
	}
	return *o.OperationType
}

// GetOperationTypeOk returns a tuple with the OperationType field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *RequestParameter) GetOperationTypeOk() (*OperationType, bool) {
	if o == nil || IsNil(o.OperationType) {
		return nil, false
	}
	return o.OperationType, true
}

// HasOperationType returns a boolean if a field has been set.
func (o *RequestParameter) HasOperationType() bool {
	if o != nil && !IsNil(o.OperationType) {
		return true
	}

	return false
}

// SetOperationType gets a reference to the given OperationType and assigns it to the OperationType field.
func (o *RequestParameter) SetOperationType(v OperationType) {
	o.OperationType = &v
}

// GetPropertyName returns the PropertyName field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *RequestParameter) GetPropertyName() string {
	if o == nil || IsNil(o.PropertyName.Get()) {
		var ret string
		return ret
	}
	return *o.PropertyName.Get()
}

// GetPropertyNameOk returns a tuple with the PropertyName field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *RequestParameter) GetPropertyNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.PropertyName.Get(), o.PropertyName.IsSet()
}

// HasPropertyName returns a boolean if a field has been set.
func (o *RequestParameter) HasPropertyName() bool {
	if o != nil && o.PropertyName.IsSet() {
		return true
	}

	return false
}

// SetPropertyName gets a reference to the given NullableString and assigns it to the PropertyName field.
func (o *RequestParameter) SetPropertyName(v string) {
	o.PropertyName.Set(&v)
}

// SetPropertyNameNil sets the value for PropertyName to be an explicit nil
func (o *RequestParameter) SetPropertyNameNil() {
	o.PropertyName.Set(nil)
}

// UnsetPropertyName ensures that no value is present for PropertyName, not even an explicit nil
func (o *RequestParameter) UnsetPropertyName() {
	o.PropertyName.Unset()
}

// GetPropertyValue returns the PropertyValue field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *RequestParameter) GetPropertyValue() string {
	if o == nil || IsNil(o.PropertyValue.Get()) {
		var ret string
		return ret
	}
	return *o.PropertyValue.Get()
}

// GetPropertyValueOk returns a tuple with the PropertyValue field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *RequestParameter) GetPropertyValueOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.PropertyValue.Get(), o.PropertyValue.IsSet()
}

// HasPropertyValue returns a boolean if a field has been set.
func (o *RequestParameter) HasPropertyValue() bool {
	if o != nil && o.PropertyValue.IsSet() {
		return true
	}

	return false
}

// SetPropertyValue gets a reference to the given NullableString and assigns it to the PropertyValue field.
func (o *RequestParameter) SetPropertyValue(v string) {
	o.PropertyValue.Set(&v)
}

// SetPropertyValueNil sets the value for PropertyValue to be an explicit nil
func (o *RequestParameter) SetPropertyValueNil() {
	o.PropertyValue.Set(nil)
}

// UnsetPropertyValue ensures that no value is present for PropertyValue, not even an explicit nil
func (o *RequestParameter) UnsetPropertyValue() {
	o.PropertyValue.Unset()
}

// GetId returns the Id field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *RequestParameter) GetId() string {
	if o == nil || IsNil(o.Id.Get()) {
		var ret string
		return ret
	}
	return *o.Id.Get()
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *RequestParameter) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Id.Get(), o.Id.IsSet()
}

// HasId returns a boolean if a field has been set.
func (o *RequestParameter) HasId() bool {
	if o != nil && o.Id.IsSet() {
		return true
	}

	return false
}

// SetId gets a reference to the given NullableString and assigns it to the Id field.
func (o *RequestParameter) SetId(v string) {
	o.Id.Set(&v)
}

// SetIdNil sets the value for Id to be an explicit nil
func (o *RequestParameter) SetIdNil() {
	o.Id.Set(nil)
}

// UnsetId ensures that no value is present for Id, not even an explicit nil
func (o *RequestParameter) UnsetId() {
	o.Id.Unset()
}

// GetCreationTime returns the CreationTime field value if set, zero value otherwise.
func (o *RequestParameter) GetCreationTime() time.Time {
	if o == nil || IsNil(o.CreationTime) {
		var ret time.Time
		return ret
	}
	return *o.CreationTime
}

// GetCreationTimeOk returns a tuple with the CreationTime field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *RequestParameter) GetCreationTimeOk() (*time.Time, bool) {
	if o == nil || IsNil(o.CreationTime) {
		return nil, false
	}
	return o.CreationTime, true
}

// HasCreationTime returns a boolean if a field has been set.
func (o *RequestParameter) HasCreationTime() bool {
	if o != nil && !IsNil(o.CreationTime) {
		return true
	}

	return false
}

// SetCreationTime gets a reference to the given time.Time and assigns it to the CreationTime field.
func (o *RequestParameter) SetCreationTime(v time.Time) {
	o.CreationTime = &v
}

func (o RequestParameter) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o RequestParameter) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if o.RequestId.IsSet() {
		toSerialize["requestId"] = o.RequestId.Get()
	}
	if !IsNil(o.OperationType) {
		toSerialize["operationType"] = o.OperationType
	}
	if o.PropertyName.IsSet() {
		toSerialize["propertyName"] = o.PropertyName.Get()
	}
	if o.PropertyValue.IsSet() {
		toSerialize["propertyValue"] = o.PropertyValue.Get()
	}
	if o.Id.IsSet() {
		toSerialize["id"] = o.Id.Get()
	}
	if !IsNil(o.CreationTime) {
		toSerialize["creationTime"] = o.CreationTime
	}
	return toSerialize, nil
}

type NullableRequestParameter struct {
	value *RequestParameter
	isSet bool
}

func (v NullableRequestParameter) Get() *RequestParameter {
	return v.value
}

func (v *NullableRequestParameter) Set(val *RequestParameter) {
	v.value = val
	v.isSet = true
}

func (v NullableRequestParameter) IsSet() bool {
	return v.isSet
}

func (v *NullableRequestParameter) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableRequestParameter(val *RequestParameter) *NullableRequestParameter {
	return &NullableRequestParameter{value: val, isSet: true}
}

func (v NullableRequestParameter) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableRequestParameter) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
